; Copyright  Kodi Studios 2012

!define FLAVOR "Release"
!define VERSION "2.11.11.0"
!define DESCRIPTION "Installs Picturethrill"
!define COPYRIGHT "Kodi Studios 2012"
!define TARGETDIR "..\..\bin\Picturethrill\Release\"

VIProductVersion "${VERSION}"
VIAddVersionKey  "FileDescription" "Picturethrill"
VIAddVersionKey  "FileVersion" "${VERSION}"
VIAddVersionKey  "ProductName" "Picturethrill"
VIAddVersionKey  "ProductVersion" "${VERSION}"
VIAddVersionKey  "LegalCopyright" " Kodi Studios"
;VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "A test comment"
;VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Kodi Studios"
;VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalTrademarks" "Test Application is a trademark of Fake company"


;Name "My Program ${VERSION}"

;Include Modern UI
!include "MUI2.nsh"

; The name of the installer
Name "Picturethrill"

; The Setup file to write
OutFile "PicturethrillSetup.exe"

; The default installation directory
; Probably sets $INSTDIR variable
InstallDir $LOCALAPPDATA\Aristov\Picturethrill

; Request application privileges for Windows 7
RequestExecutionLevel user

;--------------------------------
;Interface Settings

; TODO: What does this do?
!define MUI_ABORTWARNING

;-----------------------
; Install Pages
  
  ; Installing ProgressBar Page
  !insertmacro MUI_PAGE_INSTFILES

  ; Finish Page
  ; MUI_PAGE_FINISH definitions
    !define MUI_FINISHPAGE_RUN_TEXT "Launch Picturethrill"
    !define MUI_FINISHPAGE_RUN "$INSTDIR\Picturethrill.exe"
  !insertmacro MUI_PAGE_FINISH
  
;------------------------
; Uninstall Pages

  ; Uninstalling ProgressBar Page
  !insertmacro MUI_UNPAGE_INSTFILES
  
  ; Finish Page
  !insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Languages

!insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

; Required Component
Section "Picturethrill (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; if uninstall.exe exists, uninstall Picturethrill in silent mode
  ExecWait '"$INSTDIR\uninstall.exe" /S _?=$INSTDIR'
  
  ; Put file there
  File "${TARGETDIR}\Picturethrill.exe"
  File "${TARGETDIR}\Picturethrill.pdb"  
  File "${TARGETDIR}\PicturethrillTask.xml"
  File "${TARGETDIR}\InstalledCache.xml"
  File "${TARGETDIR}\PicturethrillUpdateTask.xml"
  File "..\..\bin\PicturethrillUpdate\Release\PicturethrillUpdate.exe"
  File "..\..\bin\PicturethrillUpdate\Release\PicturethrillUpdate.exe.config"
  File "..\..\bin\PicturethrillUpdate\Release\PicturethrillUpdate.pdb"
  
  CreateDirectory $INSTDIR\InstalledCache
  File ${TARGETDIR}\InstalledCache\*
  ; TODO: Following assumes that any jpg and png files
  ; are for cache.
  CopyFiles /SILENT $INSTDIR\*.jpg $INSTDIR\InstalledCache
  CopyFiles /SILENT $INSTDIR\*.png $INSTDIR\InstalledCache
  
  ExecWait '"$INSTDIR\Picturethrill.exe" -i'
  
  ; Write the uninstall keys for Windows  
  
  ;Icon Format: C:\Program Files\Common Files\Microsoft Shared\OFFICE14\Office Setup Controller\OSETUP.DLL,1
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "DisplayIcon" "$INSTDIR\Picturethrill.exe,0"
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "DisplayName" "Picturethrill"
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "DisplayVersion" "${VERSION}"
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "EstimatedSize" 3000
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "InstallLocation" "$INSTDIR"
    
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "NoModify" 1
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "NoRepair" 1
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "Publisher" "Kodi Studios"
  WriteRegStr   HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill" "UninstallString" '"$INSTDIR\Uninstall.exe"'
  WriteUninstaller "Uninstall.exe"
  
SectionEnd

; Optional Component
Section "Start Menu Shortcuts"

  ; $SMPROGRAMS is Start Menu Programs
  CreateDirectory "$SMPROGRAMS\Picturethrill"
  
  ;CreateShortCut link.lnk target.file [parameters [icon.file [icon_index_number [start_options [keyboard_shortcut [description]]]]]]
  CreateShortCut "$SMPROGRAMS\Picturethrill\Picturethrill.lnk" "$INSTDIR\Picturethrill.exe" "" "$INSTDIR\Picturethrill.exe" 0
  CreateShortCut "$SMPROGRAMS\Picturethrill\Uninstall.lnk" "$INSTDIR\Uninstall.exe" "" "$INSTDIR\Uninstall.exe" 0  
 
SectionEnd

; Optional Component 
Section "Desktop Shortcuts"

  ;CreateShortCut link.lnk target.file [parameters [icon.file [icon_index_number [start_options [keyboard_shortcut [description]]]]]] 
  CreateShortCut "$DESKTOP\Picturethrill.lnk" "$INSTDIR\Picturethrill.exe" "" "$INSTDIR\Picturethrill.exe" 0
  
SectionEnd

;--------------------------------
;Uninstaller Section

; "Uninstall" is a special name
; Called after UnregisterPicturethrill
Section "Uninstall"

  ; Kill any Picturethrill.exe instances  
  ; Remove Picturethrill Task From TaskManager
  ExecWait '"$INSTDIR\Picturethrill.exe" -u'

  ; Remove Windows Registration
  DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\Picturethrill"
  
  ; Remove files and uninstaller
  Delete $INSTDIR\Picturethrill.exe
  Delete $INSTDIR\Picturethrill.pdb
  Delete $INSTDIR\PicturethrillTask.xml
  Delete $INSTDIR\PicturethrillUpdate.exe
  Delete $INSTDIR\PicturethrillUpdate.exe.config
  Delete $INSTDIR\PicturethrillUpdate.pdb
  Delete $INSTDIR\PicturethrillUpdateTask.xml
  Delete $INSTDIR\Uninstall.exe
  Delete $INSTDIR\InstalledCache.xml
  RMDir /r "$INSTDIR\InstalledCache"
  ; TODO: Following assumes that .jpg and .png files
  ; are for cache.
  Delete $INSTDIR\*.jpg 
  Delete $INSTDIR\*.png 

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Picturethrill\*.*"
  Delete "$DESKTOP\Picturethrill*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Picturethrill"
  RMDir "$INSTDIR"

SectionEnd
